/**
 * @license
 *-------------------------------------------------------------------------------------------
 * Copyright © 2025 Progress Software Corporation. All rights reserved.
 * Licensed under commercial license. See LICENSE.md in the package root for more information
 *-------------------------------------------------------------------------------------------
 */
import * as o from "react";
import e from "prop-types";
import { Popup as tt } from "@progress/kendo-react-popup";
import { cloneDate as oe, getDate as nt } from "@progress/kendo-date-math";
import { validatePackage as ot, useId as rt, useAdaptiveModeContext as at, usePropsContext as lt, canUseDOM as re, AsyncFocusBlur as it, classNames as ae, kendoThemeMaps as le, createPropsContext as ut, Keys as D } from "@progress/kendo-react-common";
import { calendarIcon as st } from "@progress/kendo-svg-icons";
import { packageMetadata as ct } from "../package-metadata.mjs";
import { DateInput as dt } from "../dateinput/DateInput.mjs";
import { Calendar as ft } from "../calendar/components/Calendar.mjs";
import { nullable as a, MAX_DATE as mt, MIN_DATE as pt, isInDateRange as gt, setTime as ht } from "../utils.mjs";
import { toggleCalendar as ie, messages as vt } from "../messages/index.mjs";
import { useLocalization as wt } from "@progress/kendo-react-intl";
import { ToggleButton as bt } from "./ToggleButton.mjs";
import { PickerWrap as yt } from "../common/PickerWrap.mjs";
import { PickerFloatingLabel as Ct } from "../hooks/usePickerFloatingLabel.mjs";
import { ActionSheetContent as kt } from "@progress/kendo-react-layout";
import { AdaptiveMode as Dt } from "../common/AdaptiveMode.mjs";
const ue = o.forwardRef((n, se) => {
  ot(ct);
  const N = rt(n.id), ce = wt(), g = at(), {
    defaultShow: de = l.defaultShow,
    defaultValue: fe = l.defaultValue,
    dateInput: me = l.dateInput,
    calendar: pe = l.calendar,
    toggleButton: ge = l.toggleButton,
    popup: he = l.popup,
    pickerWrap: Pt = l.pickerWrap,
    disabled: h = l.disabled,
    format: ve = l.format,
    max: R = l.max,
    min: I = l.min,
    popupSettings: v = l.popupSettings,
    tabIndex: we = l.tabIndex,
    weekNumber: be = l.weekNumber,
    validityStyles: z = l.validityStyles,
    size: S = l.size,
    rounded: E = l.rounded,
    fillMode: _ = l.fillMode,
    autoFocus: ye = l.autoFocus,
    show: W,
    autoSwitchParts: Ce,
    autoSwitchKeys: ke,
    twoDigitYearMax: De,
    ariaLabel: Oe,
    adaptive: Mt,
    formatPlaceholder: Pe,
    adaptiveTitle: Me,
    inputAttributes: Re,
    validationMessage: L,
    visited: Rt,
    value: x,
    touched: It,
    modified: St,
    _adaptiveMode: Et = g,
    valid: K,
    focusedDate: Ie,
    id: Se,
    ...q
  } = lt(Ot, n), B = () => {
    if (re)
      return b.current && b.current.ownerDocument || window.document;
  }, s = () => !!(p.windowWidth && g && p.windowWidth <= (g == null ? void 0 : g.medium) && n.adaptive), d = () => {
    const t = O.current !== void 0 ? O.current : x !== void 0 ? x : p.value;
    return t !== null ? oe(t) : null;
  }, i = () => P.current !== void 0 ? P.current : W !== void 0 ? W : p.show, Ee = () => me || l.dateInput, _e = () => ge || l.toggleButton, xe = () => pe || l.calendar, Be = () => he || l.popup, H = () => n.required !== void 0 ? n.required : !1, T = () => {
    const t = d() || x || null, r = I, u = R, M = gt(t, r, u), A = L !== void 0, V = (!H() || t != null) && M, F = K !== void 0 ? K : V;
    return {
      customError: A,
      rangeOverflow: t && u.getTime() < t.getTime() || !1,
      rangeUnderflow: t && t.getTime() < r.getTime() || !1,
      valid: F,
      valueMissing: t === null
    };
  }, Te = (t) => {
    for (const r of t)
      k({ windowWidth: r.target.clientWidth });
  }, Ae = () => {
    c.current && c.current.focus();
  }, U = (t) => {
    y.current = t;
  }, f = (t) => {
    i() !== t && (k({ show: t }), t && n.onOpen && n.onOpen.call(void 0, { target: w.current }), !t && n.onClose && n.onClose.call(void 0, { target: w.current }));
  }, Ve = (t) => {
    const r = d();
    return r && t ? ht(t, r) : t;
  }, Fe = (t) => {
    v != null && v.onMouseDownOutside && v.onMouseDownOutside.call(void 0, t);
  }, Y = (t, r) => {
    k({ value: oe(t || void 0) }), O.current = t, P.current = !1, s() || (m.current = !0), n.onChange && n.onChange.call(void 0, {
      syntheticEvent: r.syntheticEvent,
      nativeEvent: r.nativeEvent,
      value: d(),
      show: i(),
      target: w.current
    }), O.current = void 0, P.current = void 0, f(!1);
  }, Ne = (t) => {
    const r = Ve(t.value);
    Y(r, t);
  }, $ = () => {
    const { popupClass: t, ...r } = v, u = i(), M = d(), A = M && nt(M), V = ae(t), F = {
      popupClass: "k-datepicker-popup",
      show: u,
      anchor: b.current,
      className: V,
      id: G,
      anchorAlign: {
        horizontal: "left",
        vertical: "bottom"
      },
      popupAlign: {
        horizontal: "left",
        vertical: "top"
      },
      ...r,
      onMouseDownOutside: Fe
    }, te = {
      disabled: h,
      value: A,
      min: I,
      max: R,
      weekNumber: be,
      focusedDate: Ie,
      className: s() ? "k-calendar-lg" : "",
      navigation: !s(),
      onChange: Ne
    }, ne = xe(), et = Be();
    return s() ? /* @__PURE__ */ o.createElement(ne, { _ref: U, ...te }) : /* @__PURE__ */ o.createElement(et, { ...F }, /* @__PURE__ */ o.createElement(ne, { _ref: U, ...te }));
  }, j = () => {
    k({ focused: !1 }), f(!1);
  }, ze = () => {
    const { windowWidth: t = 0 } = p, r = {
      expand: i(),
      onClose: j,
      adaptiveTitle: Me,
      windowWidth: t
    }, u = $();
    return /* @__PURE__ */ o.createElement(Dt, { ...r }, /* @__PURE__ */ o.createElement(kt, { overflowHidden: !0 }, u));
  }, We = (t) => {
    Y(t.value, t);
  }, Le = () => {
    k({ focused: !0 });
  }, Ke = () => {
    f(!i());
  }, X = () => {
    h || (m.current = !0, f(!i()));
  }, qe = (t) => {
    t.preventDefault();
  }, He = (t) => {
    const { altKey: r, keyCode: u } = t;
    if (u === D.esc && i()) {
      m.current = !0, f(!1);
      return;
    }
    r && (u === D.up || u === D.down) && (t.preventDefault(), t.stopPropagation(), m.current = u === D.up, f(u === D.down));
  }, w = o.useRef(null), b = o.useRef(null), c = o.useRef(null), y = o.useRef(null);
  o.useImperativeHandle(
    w,
    () => ({
      props: n,
      get element() {
        return b.current;
      },
      get calendar() {
        return y.current;
      },
      get dateInput() {
        return c.current;
      },
      get name() {
        return n.name;
      },
      get show() {
        return i();
      },
      get validity() {
        return T();
      },
      get value() {
        return d();
      },
      get mobileMode() {
        return s();
      },
      togglePopup: Ke,
      // Hidden Methods but still accessible
      focus: Ae
    })
  ), o.useImperativeHandle(se, () => w.current);
  const O = o.useRef(void 0), P = o.useRef(void 0), Ue = o.useRef(null), m = o.useRef(!1), Z = o.useRef(!1), C = o.useRef(null), [p, Ye] = o.useState({
    value: fe,
    show: de,
    focused: !1
  }), [, $e] = o.useReducer((t) => t, !0), k = (t) => {
    Ye((r) => ({ ...r, ...t }));
  };
  o.useEffect(() => {
    y.current && y.current.element && i() && !Z.current && y.current.element.focus({ preventScroll: !0 }), c.current && c.current.element && !i() && m.current && c.current.element.focus({ preventScroll: !0 }), Z.current = i(), m.current = !1;
  }), o.useEffect(() => {
    var t;
    return C.current = re && window.ResizeObserver && new window.ResizeObserver((r) => Te(r)), i() && $e(), (t = B()) != null && t.body && C.current && C.current.observe(B().body), () => {
      var r;
      clearTimeout(Ue.current), (r = B()) != null && r.body && C.current && C.current.disconnect();
    };
  }, []);
  const G = N + "-popup-id", je = $(), Xe = Ee(), Ze = d(), Ge = _e(), Je = ze(), J = !z || T().valid, Q = ce.toLanguageString(ie, vt[ie]), Qe = {
    disabled: h,
    format: ve,
    formatPlaceholder: Pe,
    id: Se,
    ariaLabelledBy: n.ariaLabelledBy,
    ariaDescribedBy: n.ariaDescribedBy,
    ariaLabel: Oe,
    max: R,
    min: I,
    name: n.name,
    onChange: We,
    required: n.required,
    _ref: c,
    tabIndex: i() ? -1 : we,
    title: n.title,
    valid: T().valid,
    validationMessage: L,
    validityStyles: z,
    value: Ze,
    label: void 0,
    placeholder: p.focused ? null : n.placeholder,
    ariaExpanded: i(),
    size: null,
    fillMode: null,
    rounded: null,
    autoFill: n.autoFill,
    twoDigitYearMax: De,
    enableMouseWheel: n.enableMouseWheel,
    autoCorrectParts: n.autoCorrectParts,
    autoSwitchParts: Ce,
    autoSwitchKeys: ke,
    allowCaretMode: n.allowCaretMode,
    inputAttributes: Re
  }, ee = /* @__PURE__ */ o.createElement(
    it,
    {
      onFocus: Le,
      onBlur: s() ? void 0 : j,
      onSyncBlur: n.onBlur,
      onSyncFocus: n.onFocus
    },
    (t) => /* @__PURE__ */ o.createElement(o.Fragment, null, /* @__PURE__ */ o.createElement(
      "span",
      {
        ...n.label ? {} : q,
        ref: b,
        className: ae(
          "k-input",
          "k-datepicker",
          {
            [`k-input-${le.sizeMap[S] || S}`]: S,
            [`k-rounded-${le.roundedMap[E] || E}`]: E,
            [`k-input-${_}`]: _,
            "k-invalid": !J,
            "k-required": H(),
            "k-disabled": h
          },
          n.className
        ),
        onKeyDown: He,
        style: { width: n.width },
        onFocus: t.onFocus,
        onBlur: t.onBlur,
        onClick: s() ? X : void 0
      },
      /* @__PURE__ */ o.createElement(
        Xe,
        {
          _ref: c,
          ariaRole: "combobox",
          ariaExpanded: i(),
          ariaControls: G,
          autoFocus: ye,
          ...Qe
        }
      ),
      /* @__PURE__ */ o.createElement(
        Ge,
        {
          type: "button",
          icon: "calendar",
          svgIcon: st,
          title: Q,
          className: "k-input-button",
          rounded: null,
          onClick: s() ? void 0 : X,
          "aria-label": Q,
          fillMode: _,
          onMouseDown: qe
        }
      ),
      !s() && je
    ), s() && Je)
  );
  return n.label ? /* @__PURE__ */ o.createElement(
    Ct,
    {
      dateInput: c,
      label: n.label,
      editorId: N,
      editorValid: J,
      editorDisabled: h,
      children: ee,
      style: { width: n.width },
      ...q
    }
  ) : ee;
});
ue.propTypes = {
  className: e.string,
  defaultShow: e.bool,
  defaultValue: e.instanceOf(Date),
  disabled: e.bool,
  focusedDate: e.instanceOf(Date),
  format: e.oneOfType([
    e.string,
    e.shape({
      skeleton: a(e.string),
      pattern: a(e.string),
      date: a(e.oneOf(["short", "medium", "long", "full"])),
      time: a(e.oneOf(["short", "medium", "long", "full"])),
      datetime: a(e.oneOf(["short", "medium", "long", "full"])),
      era: a(e.oneOf(["narrow", "short", "long"])),
      year: a(e.oneOf(["numeric", "2-digit"])),
      month: a(e.oneOf(["numeric", "2-digit", "narrow", "short", "long"])),
      day: a(e.oneOf(["numeric", "2-digit"])),
      weekday: a(e.oneOf(["narrow", "short", "long"])),
      hour: a(e.oneOf(["numeric", "2-digit"])),
      hour12: a(e.bool),
      minute: a(e.oneOf(["numeric", "2-digit"])),
      second: a(e.oneOf(["numeric", "2-digit"])),
      timeZoneName: a(e.oneOf(["short", "long"]))
    })
  ]),
  formatPlaceholder: e.oneOfType([
    a(
      e.oneOf(["wide", "narrow", "short", "formatPattern"])
    ),
    e.shape({
      year: a(e.string),
      month: a(e.string),
      day: a(e.string),
      hour: a(e.string),
      minute: a(e.string),
      second: a(e.string)
    })
  ]),
  id: e.string,
  ariaLabelledBy: e.string,
  ariaDescribedBy: e.string,
  ariaLabel: e.string,
  min: e.instanceOf(Date),
  max: e.instanceOf(Date),
  name: e.string,
  popupSettings: e.shape({
    animate: a(e.bool),
    appendTo: a(e.any),
    popupClass: a(e.string)
  }),
  show: e.bool,
  tabIndex: e.number,
  title: e.string,
  value: e.instanceOf(Date),
  weekNumber: e.bool,
  width: e.oneOfType([e.number, e.string]),
  validationMessage: e.string,
  required: e.bool,
  valid: e.bool,
  size: e.oneOf([null, "small", "medium", "large"]),
  rounded: e.oneOf([null, "small", "medium", "large", "full"]),
  fillMode: e.oneOf([null, "solid", "flat", "outline"]),
  adaptive: e.bool,
  adaptiveTitle: e.string,
  autoFocus: e.bool,
  inputAttributes: e.object
};
const l = {
  defaultShow: !1,
  defaultValue: null,
  dateInput: dt,
  calendar: ft,
  toggleButton: bt,
  popup: tt,
  pickerWrap: yt,
  disabled: !1,
  format: "d",
  max: mt,
  min: pt,
  popupSettings: {},
  tabIndex: 0,
  weekNumber: !1,
  validityStyles: !0,
  size: "medium",
  rounded: "medium",
  fillMode: "solid",
  autoFocus: !1
}, Ot = ut();
ue.displayName = "KendoReactDatePicker";
export {
  ue as DatePicker,
  Ot as DatePickerPropsContext,
  l as datePickerDefaultProps
};
